cdist-contrib/type/__dma_auth/gencode-remote

157 lines
3.3 KiB
Plaintext
Raw Normal View History

2020-05-29 15:33:40 +00:00
#!/bin/sh -e
#
# 2020 Dennis Camera (dennis.camera@ssrq-sds-fds.ch)
#
# This file is part of cdist.
#
# cdist is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# cdist is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with cdist. If not, see <http://www.gnu.org/licenses/>.
#
state_is=$(cat "${__object}/explorer/state")
2020-05-30 16:27:13 +00:00
state_should=$(cat "${__object}/parameter/state")
2020-05-31 09:57:54 +00:00
if test -f "${__object}/parameter/server"
2020-05-30 16:27:13 +00:00
then
2020-05-31 09:57:54 +00:00
server=$(cat "${__object}/parameter/server")
2020-05-30 16:27:13 +00:00
else
2020-05-31 09:57:54 +00:00
server=$__object_id
2020-05-30 16:27:13 +00:00
fi
2020-05-31 09:57:54 +00:00
login=$(cat "${__object}/parameter/login")
2020-05-30 16:27:13 +00:00
if test "${state_is}" = "${state_should}"
then
# state is as it should
exit 0
fi
2020-05-30 16:27:13 +00:00
case $state_should
in
(present)
2020-06-01 17:20:05 +00:00
test -n "${login}" || { echo '--login must be non-empty' >&2; exit 1; }
2020-05-30 16:27:13 +00:00
mode=1
2020-05-31 13:18:11 +00:00
if test "${state_is}" = 'absent'
2020-05-31 13:18:11 +00:00
then
printf 'add authuser %s on %s\n' "${login}" "${server}" >>"${__messages_out}"
else
printf 'set authuser %s on %s\n' "${login}" "${server}" >>"${__messages_out}"
2020-05-31 13:18:11 +00:00
fi
;;
2020-05-30 16:27:13 +00:00
(absent)
mode=0
2020-05-31 13:18:11 +00:00
printf 'delete authuser %s on %s\n' "${login}" "${server}" >>"${__messages_out}"
2020-05-30 16:27:13 +00:00
;;
(*)
printf 'Invalid --state: %s' "${state_should}" >&2
exit 1
;;
esac
auth_conf=$(cat "${__object}/explorer/auth_conf")
test -n "${auth_conf}" || {
echo 'Cannot determine path of dma auth.conf' >&2
exit 1
}
2020-05-30 16:27:13 +00:00
cat <<EOF
auth_conf='${auth_conf}'
mode=${mode}
2020-05-31 09:57:54 +00:00
EOF
2020-05-30 16:27:13 +00:00
2020-05-31 09:57:54 +00:00
cat <<'EOF'
test -f "${auth_conf}" || touch "${auth_conf}"
awk -F '\n' -v mode=$mode '
function getvalue(path) {
# Reads the first line of the file located at path and returns it.
getline < path
close(path)
return $0
}
function print_should() {
printf "%s|%s:%s\n", login_param, host_param, passwd_param
}
BEGIN {
DP = "[: \t]" # copied from dma/conf.c
parameter_dir = ENVIRON["__object"] "/parameter/"
host_param = getvalue(parameter_dir "server")
if (!host_param) host_param = ENVIRON["__object_id"]
login_param = getvalue(parameter_dir "login")
passwd_param = getvalue(parameter_dir "password")
}
# skip comments and empty lines
2020-06-11 13:09:51 +00:00
/^#/ || /^$/ {
print
next
}
{
# parse line
login = substr($0, 1, index($0, "|") - 1)
if (!login) { login = $0 } # if no "|" found
host = substr($0, length(login) + 2)
if (match(host, DP)) {
2020-06-11 13:09:51 +00:00
passwd = substr(host, RSTART + 1)
host = substr(host, 1, RSTART - 1)
} else {
passwd = ""
}
}
host == host_param {
if (mode) {
# state_should == present
if (login == login_param && !written) {
# replace line if host and login match (but only if no line has
# been written already -> no duplicates)
print_should()
written = 1
}
next
} else {
# state_should == absent
if (!login_param || login == login_param) {
# empty --login -> drop all lines for this host
next
}
}
}
# leave other lines alone
{
print
}
END {
if (mode && !written) {
# append line if no match to replace was found
print_should()
}
2020-05-30 16:27:13 +00:00
}
' <"${auth_conf}" >"${auth_conf}.tmp" \
&& mv "${auth_conf}.tmp" "${auth_conf}"
2020-05-30 16:27:13 +00:00
EOF